# Method: projects.locations.clusters.upgrade

- [HTTP request](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#body.aspect)
- [Schedule](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#Schedule)
- [Try it!](https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#try-it)

Upgrades a single cluster.

### HTTP request

`POST https://edgecontainer.googleapis.com/v1/{name=projects/*/locations/*/clusters/*}:upgrade`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The resource name of the cluster. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `edgecontainer.clusters.upgrade` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "targetVersion": string, "schedule": enum (`https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#Schedule`), "requestId": string } ``` |

| Fields ||
|---|---|
| `targetVersion` | `string` Required. The version the cluster is going to be upgraded to. |
| `schedule` | ``enum (`https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.clusters/upgrade#Schedule`)`` The schedule for the upgrade. |
| `requestId` | `string` A unique identifier for this request. Restricted to 36 ASCII characters. A random UUID is recommended. This request is only idempotent if `requestId` is provided. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/distributed-cloud/connected/1.12.0/docs/reference/container/rest/v1/projects.locations.operations#Operation`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

## Schedule

Represents the schedule about when the cluster is going to be upgraded.

| Enums ||
|---|---|
| `SCHEDULE_UNSPECIFIED` | Unspecified. The default is to upgrade the cluster immediately which is the only option today. |
| `IMMEDIATELY` | The cluster is going to be upgraded immediately after receiving the request. |